//------------------------------------------------------------------------------
//
// main.c
//
// ANTZ - 3D data viewer with realtime real-world interaction based on NPE.
//
// ANTZ is hosted at http://temporalzone.com and NPE at http://neuralphysics.org
//
// Written in 2010-2011 by Shane Saxon - contact@saxondigital.net
//
// Additional code contributed by: Mark Buchanan and Lucas Erickson.
//
// To the extent possible under law, the author(s) have dedicated all copyright 
// and related and neighboring rights to this software to the public domain
// worldwide. This software is distributed without any warranty.
//
// Released under the CC0 license, which is GPL compatible.
//
// You should have received a copy of the CC0 Public Domain Dedication along
// with this software (license file named COPYING.txt). If not, see
// http://creativecommons.org/publicdomain/zero/1.0/
//
//------------------------------------------------------------------------------

#include "io/iz/npiz.h"													//iz

//C includes after the C++ includes, else err C2766 regarding the stdbool.h
#include "npdata.h"
#include "npio.h"
#include "npctrl.h"
extern "C" 
{
	#include "io/npgl.h"					//iz	move this to npInitIO()
}

// MVC architecture variant where IO is grouped with the View
// Model named Data
// View named IO, includes GL/GPU, keyboard, mice...
// Control named Ctrl, excludes IO devices
//-----------------------------------------------------------------------------
int main (int argc, char **argv)
{
	int err = 0;
	void* data = NULL;

	data = npInitData (argc, argv);			// Model	
	npInitIO (data);						// View
	npInitCtrl (data);						// Control

	npInitGlut (0, 0, data);				//iz	move this to npInitIO()
	npInitIZ (data);						//iz	move this to npInitIO()

	err = npAppLoop (data);

	npCloseCtrl (data);
	npCloseIO (data);
	npCloseData ();							//S3D iz //npCloseData (data);

	npCloseIZ (data);						//iz	move this to npCloseIO()

  return err;
}

